#!/usr/bin/env python

import sys

from PyQt4.QtCore import *
from PyQt4.QtGui import *
from PyQt4.QtDesigner import *

# --------------------------------------------------------------------------

def loadui () :
    loader = QFormBuilder ()
    f = QFile ("examples/example.ui")
    f.open (QFile.ReadOnly)
    widget = loader.load (f)
    f.close()
    return widget

# --------------------------------------------------------------------------

tree = None

def searchItem (branch, receiver) :
    if hasattr (branch, "Tag") and branch.Tag == receiver :
       # print "FOUND"
       tree.setCurrentItem (branch)
       # tree.scrollToItem (branch)
    else :
       # if hasattr (branch, "Tag") :
       #   print "searching " + branch.text (0) + " -- " + branch.Tag.objectName () + " : " + branch.Tag.metaObject().className()
       cnt = branch.childCount ()
       for inx in range (cnt) :
           searchItem (branch.child (inx), receiver)

def onMousePress (receiver) :
    # print "mousePress " + receiver.objectName () + " : " + receiver.metaObject().className()
    cnt = tree.topLevelItemCount ()
    for inx in range (cnt) :
        searchItem (tree.topLevelItem (inx), receiver)

# --------------------------------------------------------------------------

class StructWin (QTreeWidget):

    def __init__ (self, parent=None) :
        super (StructWin, self).__init__ (parent)
        global tree
        tree = self

    def display (self, data) :
        self.displayBranch (None, data)

    def displayBranch (self, branch, data) :
        name =  data.objectName ()
        if name == "" or name.startsWith ("qt_") :
           node = branch # data are not displayed
        else :
           node = QTreeWidgetItem ()
           node.setText (0, data.objectName () + " : " + data.metaObject().className())
           node.Tag = data
           if branch == None :
              self.addTopLevelItem (node)
           else :
              branch.addChild (node)
           self.displaySignals (node, data)

        for item in data.children () :
            self.displayBranch (node, item)

    def displaySignals (self, target, data) :
        branch = QTreeWidgetItem ()
        branch.setText (0, "signals")
        target.addChild (branch)

        typ = data.metaObject ()
        cnt = typ.methodCount ()
        for inx in  range (cnt) :
            method = typ.method (inx)
            if method.methodType () == QMetaMethod.Signal :
               node = QTreeWidgetItem ()
               node.setText (0, method.signature ())
               branch.addChild (node)


# --------------------------------------------------------------------------

class Application (QApplication):

    def __init__ (self, params=None) :
       super (Application, self).__init__ (params)

    def notify (self, receiver, event) :
        if event.type() == QEvent.MouseButtonPress :
           # print "Mouse Press"
           onMousePress (receiver)
        return super (Application, self).notify (receiver, event);

# --------------------------------------------------------------------------

if __name__ == '__main__' :
   app = Application (sys.argv)
   widget = loadui ()
   widget.show ()
   win = StructWin ()
   win.display (widget)
   win.show ()
   app.exec_ ()

# --------------------------------------------------------------------------

# kate: indent-width 1; show-tabs true; replace-tabs true; remove-trailing-spaces all
