#!/usr/bin/env python

import sys

from util import use_qt5
if use_qt5 :
   from PyQt5.QtCore import *
   from PyQt5.QtGui import *
   from PyQt5.QtWidgets import *
else :
   from PyQt4.QtCore import *
   from PyQt4.QtGui import *

import pyclbr
import symtable

# --------------------------------------------------------------------------

class OrigStructWin (QTreeWidget):

    def __init__ (self, parent=None) :
        super (OrigStructWin, self).__init__ (parent)

        path = [ "." ]

        # data = pyclbr.readmodule ("struct", path)
        data = pyclbr.readmodule_ex ("loadui", path)
        # without .py extension

        for name, item in data.items ()  :
            self.displayBranch (item)

    def displayBranch (self, item) :
        node = QTreeWidgetItem ()
        node.setText (0, item.name)
        node.setToolTip (0, item.file + " " + str (item.lineno))
        self.addTopLevelItem (node)

        if hasattr (item, "methods") :
           for name, line in item.methods.items ():
               self.displayMethod (node, name, line)

    def displayMethod (self, branch, name, line) :
        node = QTreeWidgetItem ()
        node.setText (0, name)
        node.setToolTip (0, "line " + str (line))
        branch.addChild (node)

# --------------------------------------------------------------------------

class StructWin (QTreeWidget):

    def __init__ (self, parent=None) :
        super (StructWin, self).__init__ (parent)

        self.tree = self

        # fileName = "loadui.py"
        fileName = "edit.py"
        f = open (fileName, "r")
        source = f.read ()
        f.close ()

        table = symtable.symtable (source, fileName, "exec")
        self.displayBranch (None, table)

    def displayBranch (self, branch, item) :
        node = QTreeWidgetItem ()
        node.setText (0, item.get_type () + " " + item.get_name ())
        node.setToolTip (0, "line " + str (item.get_lineno ()))

        if branch == None :
           self.tree.addTopLevelItem (node)
        else :
           branch.addChild (node)

        for t in item.get_children () :
            self.displayBranch  (node, t)

# --------------------------------------------------------------------------

if __name__ == '__main__' :
   app = QApplication (sys.argv)
   win = StructWin ()
   win.show ()
   app.exec_ ()

# --------------------------------------------------------------------------

# kate: indent-width 1; show-tabs true; replace-tabs true; remove-trailing-spaces all
