#!/usr/bin/env python

import sys

from util import use_qt5
if use_qt5 :
   from PyQt5.QtCore import *
   from PyQt5.QtGui import *
   from PyQt5.QtWidgets import *
else :
   from PyQt4.QtCore import *
   from PyQt4.QtGui import *

# --------------------------------------------------------------------------

class Tree (QTreeWidget):

    def __init__ (self, parent = None) :
        super (Tree, self).__init__ (parent)
        self.win = None

        # self.setColumnCount (2)
        # self.setHeaderLabels (["Name", "Value"])
        # self.header ().setStretchLastSection (True)
        self.header ().hide ()

        self.setAlternatingRowColors (True)
        # self.setEditTriggers (QTableWidget.AllEditTriggers)
        # self.setSelectionBehavior (QTableWidget.SelectItems)
        # self.setSelectionMode (QTableWidget.SingleSelection)

        item = QTreeWidgetItem ()
        item.setText (0, "First")
        self.addTopLevelItem (item)

        branch = item

        item = QTreeWidgetItem ()
        item.setText (0, "Second")
        branch.addChild (item)

        self.itemActivated.connect (self.onItemActivated)

    def add (self, branch, node) :
        if branch == None :
           self.addTopLevelItem (node)
        else :
           branch.addChild (node)

    def onItemActivated (self, tree_node, column) :

        fileName = ""
        line = 0
        column = 0

        if hasattr (tree_node, "line") :
           line = tree_node.line

           if hasattr (tree_node, "column") :
              column = tree_node.column

           node = tree_node
           while fileName == "" and node != None :
              if hasattr (node, "fileName") :
                 fileName = node.fileName
              node = node.parent ()

        # print "click", "(" + fileName + ")", line
        if fileName != None :
           if self.win != None :
              self.win.loadFile (fileName, line)

        if hasattr (tree_node, "object") :
           self.win.showProperties (tree_node.object)


# --------------------------------------------------------------------------

if __name__ == '__main__' :
   app = QApplication (sys.argv)
   win = Tree ()
   win.show ()
   app.exec_ ()

# --------------------------------------------------------------------------

# kate: indent-width 1; show-tabs true; replace-tabs true; remove-trailing-spaces all
